#include <classes/Libraries/asl.h>

#include <exec/libraries.h>

#pragma -
#include <pragma/asl_lib.h>
#pragma +

extern struct Library *AslBase;

AslRequestC::AslRequestC(ULONG type, struct TagItem *taglist)
	: ShareC()
{
	if (!(aslRequester = AllocAslRequest(type,taglist)))
		throw AslRequestX(type);
}

AslRequestC::AslRequestC(ULONG type,Tag tag1type, ...)
	: ShareC()
{
	if (!(aslRequester = AllocAslRequest(type,(struct TagItem *) &tag1type)))
		throw AslRequestX(type);
}

AslRequestC::AslRequestC(const AslRequestC &s)
	: ShareC(s)
{
	aslRequester = s.aslRequester;
}

AslRequestC::~AslRequestC()
{
	if (only())
		FreeAslRequest(aslRequester);
}

AslRequestC &AslRequestC::operator= (const AslRequestC &s)
{
	if (this != &s)
	{
		if (only())
			FreeAslRequest(aslRequester);
		ShareC::operator= (s);
		aslRequester = s.aslRequester;
	};
	return *this;
}

BOOL AslRequestC::request(struct TagItem *taglist)
{
	return AslRequest(aslRequester,taglist);
}

BOOL AslRequestC::request(Tag tag1type, ...)
{
	return AslRequest(aslRequester,(struct TagItem *) &tag1type);
}

// ********************************************************

STRPTR AslFileRequestC::file() const
{
	return requester()->fr_File;
}

STRPTR AslFileRequestC::drawer() const
{
	return requester()->fr_Drawer;
}

// ********************************************************

TextAttrC *AslFontRequestC::attr() const
{
	if (AslBase->lib_Version >= 38)
		return (TextAttrC *) &requester()->fo_TAttr
	else
		return (TextAttrC *) &requester()->fo_Attr;
}

UBYTE AslFontRequestC::frontpen() const
{
	return requester()->fo_FrontPen;
}

UBYTE AslFontRequestC::backpen() const
{
	return requester()->fo_BackPen;
}

UBYTE AslFontRequestC::drawmode() const
{
	return requester()->fo_DrawMode;
}
